// Procdures d'extraction pour format FreeAgent
//  Version pour WdMlist 2.10B
// Auteur : Romain Petit
// Modif  : Francis MOREL
//=============================================================================
// Format fichiers reconnus : Standard FreeAgent
//
//========
//Subject: Bienvenue !
//From: "Emmanuel Haefele" <e.haefele@wanadoo.fr>
//Date: Wed, 8 Nov 2000 19:15:56 +0100
//
//=============================================================================
Fonction InitLecture(NomFichier,NumFic)
// Objet  : Initialisation de la lecture d'un fichier message et positionne sur
//  dbut 1er message
// Renvoie vrai si l'initialisation s'est correctement droule.
//
// Entree :
//	NomFich	- Nom fichier des messages  ouvrir
// Sortie :
//	NumFic	- Numro(handle) du fichier texte des messages ouvert
//
iLgDbt		est un entier=500		// Nombre maxi lignes avant dbut message	

SI NomFichier="" alors renvoyer Faux
SI Frep(NomFichier)="" alors
	Erreur("Le fichier "+sansespace(NomFichier)+" n'existe pas.")
	RENVOYER FAUX
FIN

// Ouverture du fichier et vrification du rsultat
NumFic=fOuvre(NomFichier,FOLecture+FOBinaire)
SI NumFic=-1 ALORS
	Erreur("Impossible d'ouvrir le fichier "+sansespace(NomFichier))
	RENVOYER FAUX
FIN

// Recherche dbut message 
TANTQUE pas FLGSTOP
	UneLigne = LitLigne(NumFic)
	SI DebutMessage(UneLigne) alors SORTIR
	ilgDbt--
	SI ilgDbt<=0 ou UneLigne=EOT alors 
		erreur(MessTraduit(2004))   //2004:Le premier message n'a pas t trouver dans ...
		Renvoyer Faux
	FIN	
	SI modulo(ilgDbt,10)=0 alors  Multitache(-1)
FIN
Renvoyer Vrai
//=============================================================================
Fonction LitLigne(NumFic)
// Objet  : Renvoie une ligne du fichier des messages.
//	Renvoie le caractre ASCII "EOT" si fin du fichier des messages
//	
// Entree :
//	NumFic	- Numro(handle) du fichier texte des messages ouvert
Renvoyer flitligne(NumFic)
//=============================================================================
Fonction DebutMessage(Ligne)
// Tester Si la ligne est le dbut d'un message
// Renvoie Vrai Si Oui 
ch	est une chaine

Si Ligne="========" alors 
	renvoyer Vrai
FIN
Renvoyer Faux
//=============================================================================
Fonction IgnoreLigne(Ligne,FlgAtt=Faux,cBound="",FlgFin=Faux)
//
// Objet  : Teste si la ligne doit tre ignore,
//          Teste la fin du message en cas d'attachement
//
// Entree :
//  Ligne     - Ligne du texte lue dans le fichier
//  FlgAtt    - Booleen de suppression d'un ventuel message attach
//  cBound    - Chaine marqueur du dbut du message attach
//
// Sortie :
//  FlgFin    - Mis  Vrai pour ignorer la fin du message
//
// Retour :     Vrai si la ligne doit tre ignore
//
// Globales
//  bLgnIgn   - Booleen indiquant le mode suppression du message d'origine
//  FlgSupAtt - Booleen indiquant le mode suppression des messages attachs
//
SI FlgLgnIgn ou bLgnIgn alors
	Si Gauche(Ligne,1)=">" alors renvoyer Vrai
	// Ignore la suite du texte pour le message d'origine
Fin
SI FlgAtt et FlgSupAtt alors
	SI Position(Ligne,cBound)>0 alors 
	// marqueur de fin, ignore le reste
		FlgFin=Vrai
		Renvoyer Vrai
	FIn
FIN
Renvoyer Faux
//=============================================================================
Procedure ExtraitInfo(NumFic,Ligne,cDate,cHrs,cEmet,cSujet,iType...
					 ,FlgMemo,FlgQuot,FlgAtt,cBound)
//
// Objet  : Extraire les informations du message
//
// Entree :
//  NumFic  - Numero(handle) du fichier texte des messages ouvert
//  Ligne   - Ligne du texte lue dans le fichier
// Sortie :
//  cDate   - Date du message au format Texte "AAAAMMJJ"
//  cHrs    - Heure du message au format texte "HHMMSS"
//  cEmet   - Nom emetteur (adresse...)
//  cSujet  - Sujet du message (sans type Re:, Tr:...)
//  iType   - Type message
//             1 - question origine (absence de Tr:, Re:, ...)
//             2 - rponse (presence de RE:)
//             3 - transfert (presence de Tr:)
//             4 - autre
//  FlgMemo - Entree dans texte du message
//  FlgQuot - Message en Quoted-printable
//            ("Content-Transfer-Encoding: quoted-printable")
//  FlgAtt - Message avec attachement
//            ("Content-Type: multipart")
//  cBound - Marqueur de zone pour attachement
//            ("boundary=")
//
// Cette procedure doit tre fournie par l'utilisateur afin de personnaliser
//  le dcodage des messages.
// Il en est de mme pour les procdures annexes appeles.
// Elle est appele par le programme principal apres la lecture de chaque ligne
//  de l'entte du message (tant que FlgMemo=Faux)
// L'exemple suivant permet de dcoder les messages issus du fichier "LISTWD1".
// 
// Si besoin cette procedure peut appeler "LitLigne(NumFic)" pour lire
//  la(les) ligne(s) suivante(s) du fichier, en modifiant ventuellement
//  la variable "Ligne" en retour.
// Pour le sujet il est souhaitable d'appeler la procedure "DecodeISO(cSujet)"
//  pour dcoder les caractres anormaux du sujet du message.
//------------------------------------------------------------------------------
//

ch		est une chaine
ind		est une entier
Flag	est un booleen=Faux

Si Ligne="========" alors Ligne=fLitLigne(NumFic)

Ligne=remplace(Ligne,caract(0xA0)," ")

Si Gauche(Ligne,6)="From: " alors
// Debut de message, extrait auteur
	cEmet=Remplace(sansespace(Ligne[[6  ]]),caract(34),"")
	RETOUR
Fin

Si Gauche(Ligne,6)="Date: " alors
	ExtraitDate(Sansespace(Ligne[[6  ]]),cDate,cHrs)
	FlgMemo=Vrai		// Dpart texte message aprs une ligne vide
	Ligne=fLitLigne(NumFic)
	Ligne=fLitLigne(NumFic)
	RETOUR
Fin

Si SansEspace(Ligne)="" alors 
	// Une ligne vide => fin entte
	Flag=Vrai
FIN

Si Gauche(Ligne,9)="Subject: " alors
	Flag=Vrai
	cSujet=SansEspace(Ligne[[9  ]])
FIN
Si Flag	alors 
// Sujet du message, identifie si reponse ou transfert, sinon question suppose
	iType=1
	// Enlve les chaines codes dans le sujet
	cSujet=Remplace(cSujet,TAB," ")
	DecodeISO(cSujet)
	Boucle
		ind=4
		Selon minuscule(Gauche(cSujet,3))
			Cas "re:","r: " : SI iType=1 alors iType=2
			Cas "tr:" : SI iType=1 alors iType=3			
			Cas "re " : SI iType=1 alors iType=2
			Cas "re_" : SI iType=1 alors iType=2
			Cas "tr " : SI iType=1 alors iType=3
            CAS "re["
				SI cSujet[[ind+1]] ="]" alors ind+=2
			Cas "ref","rf"
				Si cSujet[[ind]]="." alors ind++
				Si cSujet[[ind]]=" " alors ind++
				Si cSujet[[ind]]=":" alors
				 	ind++
					 SI iType=1 alors iType=2
				SINON
					Sortir
				FIN
			Autre Cas
				Sortir
		Fin
		Si cSujet[[ind]]=":" alors ind++
		cSujet=SansEspace(cSujet[[ind  ]])
		Si Gauche(cSujet,1)="_" alors cSujet=SansEspace(cSujet[[2  ]])
		Si sansespace(cSujet)="" alors cSujet="Indfini"
	Fin
	// Dpart du texte du message avec une ligne vide
	retour
Fin

RETOUR

//=============================================================================
Fonction ExtraitDate(ligne,cDate,cHrs)
// Extraire la date et l'heure aux formats 'AAAAMMJJ' et 'HHMMSS' 
//   partir de la ligne passe du type 'jour jj mois AAAA hh:mm:ss'
// Entre :
//  Ligne  - ligne contenant la chaine date ex : "Thu, 09 Nov 2000 19:32:31 +0100"
//  cDate  - Non utilise
//  cHrs   - Non utilise
//
ch	est une chaine
ind	est une entier
cm,ca,cj,cs	sont des chaines

//Thu, 09 Nov 2000 19:32:31 +0100
ch=Minuscule(Ligne)
ind=Position(ch,",")
SI ind>0 alors 
	ch=sansespace(ch[[ind+1 a ]])
FIn
//ind=Position(ch," ")
//ch=sansespace(ch[[ind+1 a ]])

//09 Nov 2000 19:32:31 +0100
ind=Position(ch," ")
cj=sansespace(ch[[1 a ind-1]])
si taille(cj)=1 alors cj="0"+cj
ch=sansespace(ch[[ind+1 a ]])

//Nov 2000 19:32:31 +0100
ind=Position(ch," ")
cm=minuscule(sansespace(ch[[1 a ind-1]]))
ch=sansespace(ch[[ind+1 a ]])
selon cm
	cas "jan" :cm="01"
	cas "feb" :cm="02"
	cas "mar" :cm="03"
	cas "apr" :cm="04"
	cas "may" :cm="05"
	cas "jun" :cm="06"
	cas "jul" :cm="07"
	cas "aug" :cm="08"
	cas "sep" :cm="09"
	cas "oct" :cm="10"
	cas "nov" :cm="11"
	cas "dec" :cm="12"
	autre cas	: cm="01"
Fin

//2000 19:32:31 +0100
ind=Position(ch," ")
ca=sansespace(ch[[1 a ind-1]])
cDate=ca+cm+cj
ch=sansespace(ch[[ind+1 a ]])

//19:32:31 +0100
cHrs=ch[[1 sur 2]]+ch[[4 sur 2]]+ch[[7 sur 2]]
renvoyer Vrai

//=============================================================================
Procedure CreeMotsCles(LstMotsCle,cDate="",cHrs="",cEmet="",cSujet="",iType="",Contenu="")
//
// Objet  : Construire la liste des mots cls du message
// Entree :
//  cDate   - Date du message au format Texte "AAAAMMJJ"
//  cHrs    - Heure du message au format texte "HHMMSS"
//  cEmet   - Nom emetteur (adresse...)
//  cSujet  - Sujet du message (sans type Re:, Tr:...)
//  iType   - Type message
//             1 - question origine (absence de Tr:, Re:, ...)
//             2 - rponse (presence de RE:)
//             3 - transfert (presence de Tr:)
//             4 - autre
//  Contenu - Texte du message
// Sortie :
//  LstMotsCle - Liste des mots cls du message (sparateur " ;")
// 
// Globale :
//  iLenMotCle - Nombre de caractres utiles d'un mot cl
//  NbChrLim   - Nombre de caractre mini pour mot cl
//
// Cette procedure peut tre fournie par l'utilisateur afin de personnaliser
//  le dcodage des mots cls du message.
// Il en est de mme pour les procdures annexes appeles.
// Elle est appelle par le programme principal apres la lecture et le dcodage
//  ventuel du message, avant l'enregistrement dans la base de donnes.
// De ce fait il est aussi possible de modifier les paramtres d'entre.
// La conversion ventuelle en "capitale" ou en minuscule ainsi que 
//  et la suppression de la marque du pluriel ou l'ignorance du mot cl
//  sont faites pour chaque mot cl dans le programme principal.
// L'exemple suivant cre la liste de mots cls  partir du champ "cSujet",
//  avec tous les mots entre "[ ]" sont pris en compte quelque soit leur
//  longueur, les autres doivent possder plus de caractres que le minimum
//  dclar.
//------------------------------------------------------------------------------
//
cTit	est une chaine
cMot	est une chaine 
i,i1,i2 est un entier
cc		est un caractere

cTit=cSujet+" "
LstMotsCle=""

// Inclus tous les mots entre "[ ]"
i1=poSition(cTit,"[")
Tantque i1>0 
	pour i2=i1+1  taille(cTit)
		cc=cTit[[i2]]
		Si cc="," ou cc=";" ou cc="[" ou cc="]" ou cc=")" ou cc="}" alors sortir
	Fin
	SI i2-i1>2 alors
		cMot=sansespace(cTit[[i1+1  i2-1]])
		LstMotsCle=LstMotsCle+Complete(cMot,iLenMotCle)+" ; "
	FIN
	SI i2>=Taille(cTit) alors 
		cTit=cTit[[1  i1-1]]
		Sortir
	FIN
	SI cc="]" ou cc=")" ou cc="}" alors		 
		cTit=cTit[[1  i1-1]]+cTit[[i2+1 a]]
		i1=poSition(cTit,"[")
	SINON
		cTit=cTit[[1  i1]]+cTit[[i2+1 a]]
	fin
Fin

// Inclus tous les mots de longueur suprieure ou gale  NbChrLim
cTit=cTit+" "
i1=1
Pour i=1  taille(cTit)+1
	cc=majuscule(cTit[[i]])
	Si (cc<"0" et cc<>".") ou (cc>"9" et cc<"A") ou cc>"_" alors
		cMot=cTit[[i1  i-1]]
		Si taille(sansespace(cMot))>=NbChrLim alors
			LstMotsCle=LstMotsCle+Complete(cMot,iLenMotCle)+" ; "
		FIN
		i1=i+1
	Fin
Fin
//=============================================================================
Procedure FinLecture(NimFic)
// Objet  : Terminer la lecture d'un fichier message
//
// Entree :
//	NumFic	- Numero(handle) du fichier texte des messages ouvert
fFerme(NumFic)

